
#include <cmath>

class Punto
{
 private:

 double X;
 double Y;

 public:

 Punto(void)
 {
  X = 0.0;
  Y = 0.0;
 }

 Punto(double x, double y)
 {
  X = x;
  Y = y;
 }

 void setX(double x)
 {
  X = x;
 }

 void setY(double y)
 {
  Y = y;
 }

 double getX(void)
 {
  return X;
 }

 double getY(void)
 {
  return Y;
 }

 // coordinata polare: distanza dall'origine
 double distanza(void)
 {
  return sqrt(X*X+Y*Y);  
 }
 
 // coordinata polare: angolo con l'asse dell'ascisse
 double angolo(void)
 {
  double angolo;
  
  if (X == 0.0 && Y == 0.0)
    return 0.0;

  angolo = 2.0*atan(Y/(distanza()+X)); // http://it.wikipedia.org/wiki/Sistema_di_coordinate_polari
  angolo = angolo*180.0/3.14159; // conversione da radianti a gradi
  return angolo;
 }
 
 // distanza dal punto P
 double distanza(Punto P)
 {
  double distanza = sqrt(pow(P.getX()-X, 2)+pow(P.getY()-Y, 2));
  return distanza;
 }

 // punto medio rispetto al punto P 
 Punto medio(Punto P)
 {
  Punto M;

  M.setX((P.getX()+X)/2.0);
  M.setY((P.getY()+Y)/2.0);
  return M;
 }
};
